import { Reducer } from 'react';
export declare type UseRestApiHandler<ResourceType> = {
    loading: boolean;
    error: Error | undefined;
    data: ResourceType | undefined;
};
export declare type UseRestApiActions<ResourceType> = {
    type: 'FETCH_INIT' | 'FETCH_SUCCESS' | 'FETCH_FAILURE' | 'CACHE_UPDATE';
    payload?: ResourceType | Error;
};
export declare type UseRestResourceReducer<ResourceType> = Reducer<UseRestApiHandler<ResourceType>, UseRestApiActions<ResourceType>>;
export declare const dataFetchReducer: <ResourceType>(state: UseRestApiHandler<ResourceType>, action: UseRestApiActions<ResourceType>) => {
    loading: boolean;
    error: undefined;
    data: ResourceType | undefined;
} | {
    data: ResourceType;
    loading: boolean;
    error: Error | undefined;
} | {
    loading: boolean;
    error: Error;
    data: ResourceType | undefined;
};
