import { RestApiResource } from '@rest-api-handler/core';
declare type UseRestApiHandler<ResourceType> = {
    loading: boolean;
    error: Error | undefined;
    data: ResourceType | undefined;
};
declare type UseRestApiActions<ResourceType> = {
    type: 'FETCH_INIT';
} | {
    type: 'FETCH_SUCCESS';
    payload: ResourceType;
} | {
    type: 'FETCH_FAILURE';
    payload: Error;
};
export declare const dataFetchReducer: <ResourceType>(state: UseRestApiHandler<ResourceType>, action: UseRestApiActions<ResourceType>) => {
    loading: boolean;
    error: undefined;
    data: ResourceType | undefined;
} | {
    loading: boolean;
    error: Error;
    data: ResourceType | undefined;
};
export declare function useApiResource<RestResource extends RestApiResource<ResourceType, any>, ReturnData extends ResourceType | ResourceType[] | undefined, ResourceType = NonNullable<ReturnType<RestResource['store']['getState']>[string]>>({ api, store, getResourceId }: RestResource, apiCall: (apiHandlers: RestResource['api']) => Promise<ReturnData>, depArray?: any[]): UseRestApiHandler<ReturnData>;
export {};
